<template>
	<span ref="spanRef">
		<el-date-picker :model-value="props.modelValue" @update:model-value="updateValue" />
	</span>
</template>

<script lang="ts" setup>
import { ElDatePicker } from "element-plus";
import { onMounted, ref, useAttrs, VNode } from "vue";

const props = defineProps<{ modelValue: Date | undefined }>();
const emit = defineEmits(['update:modelValue']);

const inputAttrs = useAttrs();

const spanRef = ref<HTMLSpanElement>();

onMounted(() => {
	setInput(input => {
		for (const name in inputAttrs) {
			const val = inputAttrs[name];
			if (val === null || val === undefined) continue;

			input.setAttribute(name, String(val));
		}
	});
})

function updateValue(val: Date) {
	// const formatted = format(val, "yyyy-MM-dd")
	emit('update:modelValue', val);
}

function setInput(clb: (input: HTMLInputElement) => void) {
	const span = spanRef.value;

	if (!span) return;

	const input = span.querySelector('input');

	if (!input) return;

	clb(input);
}

</script>